﻿#Storyline xPorter 2.1.1
#Any questions? Connect with Zsolt Olah on LinkedIn https://www.linkedin.com/in/zsoltolah1/

import zipfile
import xml.etree.ElementTree as ET
import smartsheet
import sys
import argparse


import sys
from PyQt5.QtWidgets import QApplication, QWidget, QInputDialog, QLineEdit, QFileDialog, QLabel
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QPushButton
 
import configparser

column_map ={}
columnindex_map={};
row_map = {}
var_map = {}


# ---------------------------------------------------------------------program
	
def runxPort(SMARTSHEET_ACCESS_TOKEN,sheet_id,fname):

		global column_map
		global columnindex_map
		global row_map
		global var_map

		

		# Initialize client
		smartsheet_client = smartsheet.Smartsheet(SMARTSHEET_ACCESS_TOKEN)
		
		# Check for any errors
		smartsheet_client.errors_as_exceptions(True)


		sheet = smartsheet_client.Sheets.get_sheet(sheet_id)
		print("Execution for Loaded Sheet: " + sheet.name)
		
		print("Reading existing smartsheet...")
		#Empty Dictionary
		column_map ={}
		columnindex_map={};
		i=0
		for column in sheet.columns:
		 #Map Values
		 column_map[column.title] = column.id
		 columnindex_map[column.title] = i;
		 i=i+1

		print("Thinking hard...")
		row_map = {}
		var_map = {}
		i=0 #counter
		for rows in sheet.rows:
		 
		 #Map Row ID
		 row_map[i]=rows.id
		 var_map[rows.cells[columnindex_map["Name"]].display_value]=rows.id
		 new_cell = smartsheet_client.models.Cell()
		 #Update column Remaining
		 new_cell.column_id = column_map["Status"]
		 new_cell.value = "D"
		 new_cell.strict = False
		 # Build the row to update
		 get_row = smartsheet.models.Row()
		 get_row.id = rows.id
		 get_row.cells.append(new_cell)
		 updated_row = smartsheet_client.Sheets.update_rows(sheet_id,[get_row])
		 
		 i=i+1




		print("Opening "+fname)
		print("Extracting variables...") 
		zf = zipfile.ZipFile(fname)
		for filename in [ 'story/story.xml' ]:
			try:
				data = zf.read(filename)
			except KeyError:
				print('ERROR: Did not find %s in zip file' % filename)
			else:
				print("Extracting variables...")
				print(filename + ':')
				root = ET.fromstring(data)
				for varslist in root.findall('varLst'):
					for var in varslist:
						

							if (var.get('type')=='user'):
								
								slname = var.get('name')
								print (slname)
								if slname in var_map:
									print("Parsing existing variable: " + slname)
									#updated_row = updateRows(,"Name",var.get("name"),False)

									updated_row = updateRows(smartsheet_client,var_map[slname],"Status","U",False)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"isRandom",var.get("isRandom")=="true",False)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Random min",var.get("randomMin"),False)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Random max",var.get("randomMax"),False)
								
									removed_value = var_map.pop(slname)						

								else:
									print("Adding new variable: " + var.get('name'))
									updated_row = updateRows(smartsheet_client,"","Name",var.get("name"),True)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Status","N",False)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"isRandom",var.get("isRandom")=="true",False)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Random min",var.get("randomMin"),False)
									updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Random max",var.get("randomMax"),False)
									


								updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Type",var.get("dataType"),False)
								updated_row = updateRows(smartsheet_client,updated_row.data[0].id,"Default",var.get("val"),False)

								
				print("List of variables no longer in the Storyline project: " , var_map)				
				print("Operation complete. Refresh your smartsheet!")						

									

class App(QWidget):

    def __init__(self):
        super().__init__()
        self.title = 'Storyline 360 Variable xPorter v2.1'
        self.left = 50
        self.top = 50
        self.width = 640
        self.height = 480
        self.initUI()
    
    def initUI(self):
        self.setWindowTitle(self.title)
        self.setGeometry(self.left, self.top, self.width, self.height)
        
        
        
        self.openFileNameDialog()
        self.label = QLabel('Storyline 360 Variable xPorter v2.1. Operation complete. You may close this window now.', self)
        self.label.move(50,50)
        self.show();
        
    
    def openFileNameDialog(self):
        
        global SMARTSHEET_ACCESS_TOKEN
        global sheet_id
        global fname

        
        options = QFileDialog.Options()
        options |= QFileDialog.DontUseNativeDialog
        fileName, _ = QFileDialog.getOpenFileName(self,"QFileDialog.getOpenFileName()", "","Storyline xPorter files (xporter*.ini)", options=options)
        if fileName:
            config.read(fileName,encoding='UTF-8')
            if SMARTSHEET_ACCESS_TOKEN == "" or SMARTSHEET_ACCESS_TOKEN == None:
            	SMARTSHEET_ACCESS_TOKEN = config['smartsheet']['access']
            
            if SMARTSHEET_ACCESS_TOKEN != "":
            	sheet_id = config['smartsheet']['sheetid']
            	fname = config['storyline']['filepath']            
            	print("Analyzing "+fname)
            	print (SMARTSHEET_ACCESS_TOKEN)
            	runxPort(SMARTSHEET_ACCESS_TOKEN,sheet_id,fname)
            else:
            	print("Missing smartheet access token! You must supply the token in the .ini file or command line with -a.")
	

            
    
    




# supporting functions
def updateRows(smartsheet_client,rid,cname,slvar,new = True):
	new_cell = smartsheet_client.models.Cell()
	#Update column Remaining
	new_cell.column_id = column_map[cname]
	
	new_cell.value = slvar
	new_cell.strict = False
	# Build the row to update
	get_row = smartsheet.models.Row()

	if (new == True):
		get_row.toBottom=True
		get_row.cells.append(new_cell)
		updated_row = smartsheet_client.Sheets.add_rows(sheet_id,[get_row])
	else:
		get_row.id = rid
		get_row.cells.append(new_cell)
		updated_row = smartsheet_client.Sheets.update_rows(sheet_id,[get_row])	

	return updated_row
 
#-------------------------------------------------------args	

if __name__ == "__main__":
	
	parser = argparse.ArgumentParser()
	SMARTSHEET_ACCESS_TOKEN = ""
	sheet_id = ""
	fname = ""	
	parser = argparse.ArgumentParser(description='Storyline variable exporter.')
	parser.add_argument("-a", "--sheetaccesstoken", help="Sheet access token")
	


	
	args = parser.parse_args()
	
	if args.sheetaccesstoken !="":
		SMARTSHEET_ACCESS_TOKEN = args.sheetaccesstoken

	config = configparser.ConfigParser()
	app = QApplication(sys.argv)
	ex = App()
	sys.exit(app.exec_())
    
    	
	

									
						
			   